''
'' Demo to toggle pin 16 N times
''

CON
  _clkmode = xtal1 + pll16x
  _clkfreq = 80_000_000
  pin = 16

OBJ
#ifdef __P2__
  fds : "SimpleSerial.spin"
#else
  fds : "FullDuplexSerial.spin"
#endif

PUB run | i,x,now,elapsed

  '' start up the serial port
  fds.start(31, 30, 0, 115200)

  '' set up pin 16 as an output
  DIRA[pin] := 1
  OUTA[pin] := 0

  '' and now do the toggle
  now := cnt
  '' select the kind of toggle you want to do here
  ''   toggle1(1000)
  '' toggle2(1000)
  toggle3(1000)
  elapsed := cnt - now
  fds.str(string("1000 toggles takes "))
  fds.dec(elapsed)
  fds.str(string(" cycles", 13, 10))
  fds.str(string("toggle rate: "))
  fds.dec( 80_000_000 / elapsed )
  fds.str(string(" kHz at 80 MHz sysclock", 13, 10))
  '' now just hang
  fds.str(string("done", 13, 10))
  repeat

PUB toggle1(n)
  REPEAT n
    OUTA++

PUB toggle2(n)
  REPEAT n
    OUTA++
    OUTB++

PUB toggle3(n)
  REPEAT n
    OUTA := OUTA+1
    OUTB := OUTB+1

